#include <stdio.h>
#include <malloc.h>
#include "load.image.h"

void bwToCpack(unsigned short *, unsigned long *, int);
void rgbToCpack( unsigned short *,  unsigned short *, unsigned short *,
	 unsigned long *,  int);
void rgbaToCpack( unsigned short *, unsigned short *, unsigned short *,
	 unsigned short *, unsigned long *,  int);
void rgbaToCpackCond( unsigned short *, unsigned short *, unsigned short *,
	 unsigned short *, unsigned long *,  int, 
	 unsigned short,  unsigned short,  unsigned short,  unsigned short);

unsigned long *readLongImageData(char *name, long *width, long *height)
{
    unsigned long *base, *lptr;
    unsigned short *rbuf, *gbuf, *bbuf, *abuf;
    IMAGE *image;
    int y,  jj;

    image = iopen(name,"r");
    if(!image) {
	return NULL;
    }
    *width = image->xsize;
    *height = image->ysize;
    base = (unsigned long *)malloc(image->xsize*image->ysize*sizeof(unsigned long));
    rbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    gbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    bbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    abuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    if(!base || !rbuf || !gbuf || !bbuf) {
	fprintf(stderr,"readLongImageData: can't malloc enough memory\n");
	exit(1);
    }
    lptr = base;
    for(y=0; y<image->ysize; y++) {
	if(image->zsize>=4) {
	    if(y==0)
		printf("Doing 4 component texture : %s \n",  name);
	  /* getrow(image,rbuf,y,0);
	    getrow(image,gbuf,y,1);
	    getrow(image,bbuf,y,2);
	    getrow(image,abuf,y,3); */
	    
	    getrow(image,abuf,y,0);
	    getrow(image,rbuf,y,1);
	    getrow(image,gbuf,y,2);
	    getrow(image,bbuf,y,3); 
	    rgbaToCpack(rbuf,gbuf,bbuf,abuf,lptr,image->xsize); 
	    lptr += image->xsize;
	} else if(image->zsize==3) {
	    if(y==0)
		printf("Doing 3 component texture : %s \n",  name);
	    getrow(image,bbuf,y,0);
	    getrow(image,gbuf,y,1);
	    getrow(image,rbuf,y,2);
	    rgbToCpack(rbuf,gbuf,bbuf,lptr,image->xsize);
	    lptr += image->xsize;
	} else {
	    if(y==0)
		printf("Doing 1 component texture : %s \n",  name);
	    getrow(image,rbuf,y,0);
	    bwToCpack(rbuf,lptr,image->xsize);
	    lptr += image->xsize;
	}
    }
    iclose(image);
    free(rbuf);
    free(gbuf);
    free(bbuf);
    free(abuf);
    return base;
}

void bwToCpack( unsigned short *b, unsigned long *l, int n)
{
    while(n>=8) {
	l[0] = 0x00010101*b[0];
	l[1] = 0x00010101*b[1];
	l[2] = 0x00010101*b[2];
	l[3] = 0x00010101*b[3];
	l[4] = 0x00010101*b[4];
	l[5] = 0x00010101*b[5];
	l[6] = 0x00010101*b[6];
	l[7] = 0x00010101*b[7];
	l += 8;
	b += 8;
	n -= 8;
    }
    while(n--) 
	*l++ = 0x00010101*(*b++);
}

void rgbToCpack( unsigned short *r, unsigned short *g, unsigned short *b,
	 unsigned long *l,  int n)
{
unsigned short a,  aval;
   
   aval  = 255;
    
    a = aval; /* Object non transparent */
    
    while(n>=8) {
	l[0] = a | (r[0]<<8) | (g[0]<<16) | (b[0]<<24);
	l[1] = a | (r[1]<<8) | (g[1]<<16) | (b[1]<<24);
	l[2] = a | (r[2]<<8) | (g[2]<<16) | (b[2]<<24);
	l[3] = a | (r[3]<<8) | (g[3]<<16) | (b[3]<<24);
	l[4] = a | (r[4]<<8) | (g[4]<<16) | (b[4]<<24);
	l[5] = a | (r[5]<<8) | (g[5]<<16) | (b[5]<<24);
	l[6] = a | (r[6]<<8) | (g[6]<<16) | (b[6]<<24);
	l[7] = a | (r[7]<<8) | (g[7]<<16) | (b[7]<<24);
	
	/*
	l[0] = r[0] | (g[0]<<8) | (b[0]<<16) | a <<24;
	a = aval;
	l[1] = r[1] | (g[1]<<8) | (b[1]<<16) | a <<24;
	a = aval;
	l[2] = r[2] | (g[2]<<8) | (b[2]<<16) | a <<24;
	a = aval;
	l[3] = r[3] | (g[3]<<8) | (b[3]<<16) | a <<24;
	a = aval;
	l[4] = r[4] | (g[4]<<8) | (b[4]<<16) | a <<24;
	a = aval;
	l[5] = r[5] | (g[5]<<8) | (b[5]<<16) | a <<24;
	a = aval;
	l[6] = r[6] | (g[6]<<8) | (b[6]<<16) | a <<24;
	a = aval;
	l[7] = r[7] | (g[7]<<8) | (b[7]<<16) | a <<24;
	*/
	l += 8;
	r += 8;
	g += 8;
	b += 8;
	n -= 8;
    }
    while(n--)
    { 
    	a = aval;
        *l++ = *r++ | ((*g++)<<8) | ((*b++)<<16) | a<<24;
	}
}

void rgbaToCpack( unsigned short *r, unsigned short *g, unsigned short *b,
	 unsigned short *a, unsigned long *l,  int n)
{
    while(n>=8) {
    
#if 0	
    r[0] = 0;
    r[1] = 0;
    r[2] = 0;
    r[3] = 0;
    r[4] = 0;
    r[5] = 0;
    r[6] = 0;
    r[7] = 0;
    
    if(*a == 0&& *g == 0 && *b == 0)
	    *r = 0;	    
#endif	    

	
	l[0] = r[0] | (g[0]<<8) | (b[0]<<16) | (a[0]<<24);	
	l[1] = r[1] | (g[1]<<8) | (b[1]<<16) | (a[1]<<24);	
	l[2] = r[2] | (g[2]<<8) | (b[2]<<16) | (a[2]<<24);	
	l[3] = r[3] | (g[3]<<8) | (b[3]<<16) | (a[3]<<24);	
	l[4] = r[4] | (g[4]<<8) | (b[4]<<16) | (a[4]<<24);	
	l[5] = r[5] | (g[5]<<8) | (b[5]<<16) | (a[5]<<24);	
	l[6] = r[6] | (g[6]<<8) | (b[6]<<16) | (a[6]<<24);    
	l[7] = r[7] | (g[7]<<8) | (b[7]<<16) | (a[7]<<24);
	l += 8;
	r += 8;
	g += 8;
	b += 8;
	a += 8;
	n -= 8;
    }
	
    while(n--) 
    {
	
        *l++ = *r++ | ((*g++)<<8) | ((*b++)<<16) | ((*a++)<<24);
	}
}






unsigned long *readLongImageDataCond(char *name, long *width, long *height, 
				unsigned short rt,  unsigned short gt,  unsigned short bt, 
				unsigned short comp)
{
    unsigned long *base, *lptr;
    unsigned short *rbuf, *gbuf, *bbuf, *abuf;
    IMAGE *image;
    int y,  jj;

    image = iopen(name,"r");
    if(!image) {
	return NULL;
    }
    *width = image->xsize;
    *height = image->ysize;
    base = (unsigned long *)malloc(image->xsize*image->ysize*sizeof(unsigned long));
    rbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    gbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    bbuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    abuf = (unsigned short *)malloc(image->xsize*sizeof(short));
    if(!base || !rbuf || !gbuf || !bbuf) {
	fprintf(stderr,"readLongImageData: can't malloc enough memory\n");
	exit(1);
    }
    lptr = base;
    for(y=0; y<image->ysize; y++) {
	if(image->zsize>=4) {
	    if(y==0)
		printf("Doing 4 component texture : %s \n",  name);
	  /* getrow(image,rbuf,y,0);
	    getrow(image,gbuf,y,1);
	    getrow(image,bbuf,y,2);
	    getrow(image,abuf,y,3); */
	    
	    getrow(image,abuf,y,0);
	    getrow(image,bbuf,y,1);
	    getrow(image,gbuf,y,2);
	    getrow(image,rbuf,y,3); 
	    rgbaToCpackCond(rbuf,gbuf,bbuf,abuf,lptr,image->xsize,  rt,  gt,  bt,  comp); 
	    lptr += image->xsize;
	} else if(image->zsize==3) {
	    if(y==0)
		printf("Doing 3 component texture : %s \n",  name);
	    getrow(image,rbuf,y,0);
	    getrow(image,gbuf,y,1);
	    getrow(image,bbuf,y,2);
	    rgbToCpack(rbuf,gbuf,bbuf,lptr,image->xsize);
	    lptr += image->xsize;
	} else {
	    if(y==0)
		printf("Doing 1 component texture : %s \n",  name);
	    getrow(image,rbuf,y,0);
	    bwToCpack(rbuf,lptr,image->xsize);
	    lptr += image->xsize;
	}
    }
    iclose(image);
    free(rbuf);
    free(gbuf);
    free(bbuf);
    free(abuf);
    return base;
}

void rgbaToCpackCond( unsigned short *r, unsigned short *g, unsigned short *b,
	 unsigned short *a, unsigned long *l,  int n, 
	 unsigned short rt,  unsigned short gt,  unsigned short bt,  unsigned short comp)
{
    while(n>=8) {
    
	switch(comp)
	{
	case 0:
	    if(a[0]  == rt && g[0] == gt && b[0] == bt)	    r[0] = 0;
	    if(a[1]  == rt && g[1] == gt && b[1] == bt)	    r[1] = 0;
	    if(a[2]  == rt && g[2] == gt && b[2] == bt)	    r[2] = 0;
	    if(a[3]  == rt && g[3] == gt && b[3] == bt)	    r[3] = 0;
	    if(a[4]  == rt && g[4] == gt && b[4] == bt)	    r[4] = 0;
	    if(a[5]  == rt && g[5] == gt && b[5] == bt)	    r[5] = 0;
	    if(a[6]  == rt && g[6] == gt && b[6] == bt)	    r[6] = 0;
	    if(a[7]  == rt && g[7] == gt && b[7] == bt)	    r[7] = 0;
	    break;
	case 1:
	    if(a[0]  <= rt && g[0] <= gt && b[0] <= bt)	    r[0] = 0;
	    if(a[1]  <= rt && g[1] <= gt && b[1] <= bt)	    r[1] = 0;
	    if(a[2]  <= rt && g[2] <= gt && b[2] <= bt)	    r[2] = 0;
	    if(a[3]  <= rt && g[3] <= gt && b[3] <= bt)	    r[3] = 0;
	    if(a[4]  <= rt && g[4] <= gt && b[4] <= bt)	    r[4] = 0;
	    if(a[5]  <= rt && g[5] <= gt && b[5] <= bt)	    r[5] = 0;
	    if(a[6]  <= rt && g[6] <= gt && b[6] <= bt)	    r[6] = 0;
	    if(a[7]  <= rt && g[7] <= gt && b[7] <= bt)	    r[7] = 0;
	    break;
	case 2:
	    if(a[0]  >= rt && g[0] >= gt && b[0] >= bt)	    r[0] = 0;
	    if(a[1]  >= rt && g[1] >= gt && b[1] >= bt)	    r[1] = 0;
	    if(a[2]  >= rt && g[2] >= gt && b[2] >= bt)	    r[2] = 0;
	    if(a[3]  >= rt && g[3] >= gt && b[3] >= bt)	    r[3] = 0;
	    if(a[4]  >= rt && g[4] >= gt && b[4] >= bt)	    r[4] = 0;
	    if(a[5]  >= rt && g[5] >= gt && b[5] >= bt)	    r[5] = 0;
	    if(a[6]  >= rt && g[6] >= gt && b[6] >= bt)	    r[6] = 0;
	    if(a[7]  >= rt && g[7] >= gt && b[7] >= bt)	    r[7] = 0;	    
	    break;	    
	}
	
	l[0] = r[0] | (g[0]<<8) | (b[0]<<16) | (a[0]<<24);	
	l[1] = r[1] | (g[1]<<8) | (b[1]<<16) | (a[1]<<24);	
	l[2] = r[2] | (g[2]<<8) | (b[2]<<16) | (a[2]<<24);	
	l[3] = r[3] | (g[3]<<8) | (b[3]<<16) | (a[3]<<24);	
	l[4] = r[4] | (g[4]<<8) | (b[4]<<16) | (a[4]<<24);	
	l[5] = r[5] | (g[5]<<8) | (b[5]<<16) | (a[5]<<24);	
	l[6] = r[6] | (g[6]<<8) | (b[6]<<16) | (a[6]<<24);    
	l[7] = r[7] | (g[7]<<8) | (b[7]<<16) | (a[7]<<24);
	l += 8;
	r += 8;
	g += 8;
	b += 8;
	a += 8;
	n -= 8;
    }
	
    while(n--) 
    {
	if(*a == 0&& *g == 0 && *b == 0)
	    *r = 0;
        *l++ = *r++ | ((*g++)<<8) | ((*b++)<<16) | ((*a++)<<24);
	}
}


