#ifndef _ROBOT_H_ 
#define _ROBOT_H_ 

/*
  robot.h

  Frode Aarstad 20.02.2000

 */

#include "../inc/glut.h"
#include <Math/vjVec3.h>
#include <Math/vjMatrix.h>
#include <LEDA/list.h>
#include "util.h"


class robot {

public:
  robot();
  ~robot();

  virtual void placeRobot(vjMatrix*) {};
  void moveRobot(vjMatrix*);
  virtual void draw(int);
  
  PQP_Model * getRobotModel();

  PQP_REAL R[3][3];
  PQP_REAL T[3];
  vjVec3 pos;

protected:
  int placed;
  int robotList;
  PQP_Model *robotModel;
  list <triangle3d *> O;
};

/*
  The robots

 */

class goal : public robot {
public:
  goal();
  virtual void placeRobot(vjMatrix*);

};

class flying : public robot {
public:
  flying();
  virtual void placeRobot(vjMatrix*);
  virtual void draw(int);

private:
  int bigRotorList;
  int smallRotorList;
  float bigProp;
  float smallProp; 
};


class rolling : public robot {
public:
  rolling();
  virtual void placeRobot(vjMatrix*);

};
#endif






