/*
  vmenu.cpp
  
  Frode Aarstad
 */

#include "vmenu.h"


vmenu::vmenu(float x, float y, vjVec3 v)
{
  frame = glGenLists(1);
  glNewList(frame, GL_COMPILE);
  glColor4f(0.1, 0.1, 1.0, 0.0);
  glBegin(GL_POLYGON);
     // bottom
    glNormal3f(0.0, -1.0, 0.0);glVertex3f(0.0, 0.0, 0.0);
    glNormal3f(0.0, -1.0, 0.0);glVertex3f(1.0, 0.0, 0.0);
    glNormal3f(0.0, -1.0, 0.0);glVertex3f(1.0, 0.0, 1.0);
    glNormal3f(0.0, -1.0, 0.0);glVertex3f(0.0, 0.0, 1.0);
  glEnd();
  glBegin(GL_POLYGON);
    //top
    glNormal3f(0.0, 1.0, 0.0);glVertex3f(0.0, 1.0, 0.0);
    glNormal3f(0.0, 1.0, 0.0);glVertex3f(1.0, 1.0, 0.0);
    glNormal3f(0.0, 1.0, 0.0);glVertex3f(1.0, 1.0, 1.0);
    glNormal3f(0.0, 1.0, 0.0);glVertex3f(0.0, 1.0, 1.0);
  glEnd();
  glBegin(GL_POLYGON);  
    //front
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, 0.0, 1.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(1.0, 0.0, 1.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(1.0, 1.0, 1.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, 1.0, 1.0);
  glEnd();
  glBegin(GL_POLYGON);
    glNormal3f(-1.0, 0.0, 0.0);glVertex3f(0.0, 0.0, 0.0);
    glNormal3f(-1.0, 0.0, 0.0);glVertex3f(0.0, 0.0, 1.0);
    glNormal3f(-1.0, 0.0, 0.0);glVertex3f(0.0, 1.0, 1.0);
    glNormal3f(-1.0, 0.0, 0.0);glVertex3f(0.0, 1.0, 0.0);
  glEnd();
  glBegin(GL_POLYGON);
    glNormal3f(1.0, 0.0, 0.0);glVertex3f(1.0, 0.0, 0.0);
    glNormal3f(1.0, 0.0, 0.0);glVertex3f(1.0, 0.0, 1.0);
    glNormal3f(1.0, 0.0, 0.0);glVertex3f(1.0, 1.0, 1.0);
    glNormal3f(1.0, 0.0, 0.0);glVertex3f(1.0, 1.0, 0.0);
  glEnd();
  glBegin(GL_POLYGON);
    //back
    glNormal3f(0.0, 0.0, -1.0);glVertex3f(0.0, 0.0, 0.0);
    glNormal3f(0.0, 0.0, -1.0);glVertex3f(1.0, 0.0, 0.0);
    glNormal3f(0.0, 0.0, -1.0);glVertex3f(1.0, 1.0, 0.0);
    glNormal3f(0.0, 0.0, -1.0);glVertex3f(0.0, 1.0, 0.0); 
  glEnd();
  glEndList();

  vmenu_base = glGenLists(1);
  glNewList(vmenu_base, GL_COMPILE);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glColor4f(0.2, 0.9, 0.1, 0.5);
  glBegin(GL_POLYGON);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, 0.0, 0.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, y, 0.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(x,y, 0.0);
    glNormal3f(0.0, 0.0, 1.0);glVertex3f(x, 0.0, 0.0);
  glEnd();
  glDisable(GL_BLEND);

  glPushMatrix();
    glScalef(0.15, y, 0.15);
    glCallList(frame);
  glPopMatrix();   

  glPushMatrix();
    glScalef(x, 0.15, 0.15);
    glCallList(frame);
  glPopMatrix();   

  glPushMatrix();
    glTranslatef(x, 0.0, 0.0);
    glScalef(0.15, y+0.15, 0.15);
    glCallList(frame);
  glPopMatrix();   

  glPushMatrix();
    glTranslatef(0.0, y, 0.0);
    glScalef(x, 0.15, 0.15);
    glCallList(frame);
  glPopMatrix();  

  glEndList();

  //make a PQPmodel of the wand
  PQP_REAL p1[3], p2[3], p3[3];
  p1[0]= 0.0; p1[1]= 0.0; p1[2]= 0.0;
  p2[0]= 0.2; p2[1]= 0.0; p2[2]= 0.0;
  p3[0]= 0.2; p3[1]= 0.2; p3[2]= 0.0;

  wandModel = new PQP_Model();
  wandModel->BeginModel();
  wandModel->AddTri(p1, p2, p3, 0);
  wandModel->EndModel();

  Rwand[0][0] = Rwand[1][1] = Rwand[2][2] = 1.0;
  Rwand[0][1] = Rwand[1][0] = Rwand[2][0] = 0.0;
  Rwand[0][2] = Rwand[1][2] = Rwand[2][1] = 0.0;
  
  Twand[0] = 0.0; Twand[1] = 0.0; Twand[2] = 0.0;

  pos_vec = v;
}



vmenu::~vmenu()
{
  M.clear();
  delete wandModel;
}



string vmenu::selected(vjMatrix *wand, vjMatrix *head)
{   
  // change to tolerance result

  float x,y,z;
  string str = "idle";
  PQP_DistanceResult dres;

  wand->getTrans(x,y,z);
  Twand[0] = (PQP_REAL)x;  Twand[1] = (PQP_REAL)y; Twand[2] = (PQP_REAL)z;

  menuItem *m;
  for (int i= 0; i< M.size(); i++) {
    m=M.inf(M[i]);
    if (m->M.size() > 0 && m->visible == 1) {
      menuItem *mm;
      forall(mm, m->M) {
	PQP_Distance(&dres, mm->R, mm->T, mm->model,
		     Rwand, Twand, wandModel, 0.0,0.0);
	if (dres.Distance() < 0.2) {
	  str = mm->id;
	  mm->draw(1, head);
	  i = M.size();
	}
      }
    }
  }
  if (visibleSubmenu() == 0) {
    for (int j= 0; j< M.size(); j++) {
      m=M.inf(M[j]);
      PQP_Distance(&dres, m->R, m->T, m->model,
		   Rwand, Twand, wandModel, 0.0,0.0);

      if (dres.Distance() < 0.2) {
	str = m->id;
	if (m->M.size() >0 && m->visible==1) m->draw(0, head);
	else m->draw(1, head);
	j = M.size();
      }
    }
  }
  return str;
}



void vmenu::draw(vjMatrix *head)
{
  menuItem *m;

  glPushMatrix();
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glLoadIdentity();
    glMultMatrixf(head->getFloatPtr());
    glTranslatef(pos_vec[0], pos_vec[1], pos_vec[2]);
    glCallList(vmenu_base);
    glDisable(GL_BLEND);
  glPopMatrix();  
  
  forall(m, M) m->draw(0, head);
}



void vmenu::addMenuItem(menuItem *m)
{
  M.push(m);
}



void vmenu::reset()
{
  menuItem *m;
  forall(m, M) 
    m->visible = 0;
}



int vmenu::drawSubmenu(string str, vjMatrix *head)
{
  menuItem *m;
  int tmp = 0;


  // try to use ust the matrix stack in stead..
  /*
  vjMatrix tmp_mat;
  vjMatrix *new_head;

  tmp_mat.makeTrans(pos_vec[0], pos_vec[1], pos_vec[2]);
  new_head = new vjMatrix();
  new_head = head;
  new_head->postMult(tmp_mat);
  */

  if (str != "") {
    forall(m, M) {
      if (m->id == str && m->M.size() > 0) {
	m->draw(1, head);
	tmp = 1;
	m->visible = 1;
      }
    }
  }
  else tmp = 1;
  return tmp;  
}



int vmenu::visibleSubmenu()
{
  int tmp = 0;
  menuItem *m;
 
  forall(m, M)
    tmp = tmp + m->visible;
  
  return tmp;
}



void vmenu::hideSubmenu()
{
  menuItem *m;
  
  forall(m, M)
    m->visible = 0;
}





menuItem::menuItem(float x, float y, vector pos, char * texture, string text)
{
  long sizeX, sizeY;
  unsigned long *image;

  if (texture != "none") {
    glGenTextures(1, item_texture);
    glBindTexture(GL_TEXTURE_2D, item_texture[0]);
    glEnable(GL_TEXTURE_2D);
    image = readLongImageData(texture, &sizeX, &sizeY);
    glTexImage2D(GL_TEXTURE_2D, 0, 4, sizeX, sizeY, 0, 
		 GL_RGBA, GL_UNSIGNED_BYTE, image);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  GL_MODULATE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glDisable(GL_TEXTURE_2D); 

    item = glGenLists(1);
    glNewList(item, GL_COMPILE);
    glBindTexture(GL_TEXTURE_2D, item_texture[0]);
    glEnable(GL_TEXTURE_2D);
    glColor4f(1.0, 1.0, 1.0, 0.0);
    glBegin(GL_POLYGON);
      glTexCoord2i(0,0);glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, 0.0, 0.1);
      glTexCoord2i(0,1);glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, y, 0.1);
      glTexCoord2i(1,1);glNormal3f(0.0, 0.0, 1.0);glVertex3f(x,y, 0.1);
      glTexCoord2i(1,0);glNormal3f(0.0, 0.0, 1.0);glVertex3f(x, 0.0, 0.1);
    glEnd();
    glDisable(GL_TEXTURE_2D);
    glEndList();
  }
  else {
    item = glGenLists(1);
    glNewList(item, GL_COMPILE);
    glColor4f(0.5, 0.0, 0.5, 0.0);
    glBegin(GL_POLYGON);
      glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, 0.0, 0.1);
      glNormal3f(0.0, 0.0, 1.0);glVertex3f(0.0, y, 0.1);
      glNormal3f(0.0, 0.0, 1.0);glVertex3f(x,y, 0.1);
      glNormal3f(0.0, 0.0, 1.0);glVertex3f(x, 0.0, 0.1);
    glEnd();
    glEndList();
  } 

  id = text;
  visible = 0;
  
  // PQP stuff
  R[0][0] = R[1][1] = R[2][2] = 1.0;
  R[0][1] = R[1][0] = R[2][0] = 0.0;
  R[0][2] = R[1][2] = R[2][1] = 0.0;
 
  T[0] = pos[0];  T[1] = pos[1]; T[2] = pos[2];

  PQP_REAL p1[3],p2[3],p3[3], p4[3];
  p1[0]= 0.0; p1[1]= 0.0; p1[2]= 0.0;
  p2[0]= 0.0; p2[1]= y; p2[2]= 0.0;
  p3[0]= x; p3[1]= y; p3[2]= 0.0;
  p4[0]= x; p4[1]= 0; p4[2]= 0.0;

  model = new PQP_Model();
  model->BeginModel();
  model->AddTri(p1, p2, p3,1);
  model->AddTri(p3, p4, p1,2);
  model->EndModel();

  // setting up the matrix for the menuItem.
  itemMat[0] = 1.0;
  itemMat[1] = itemMat[2]  = itemMat[3] = itemMat[4] = 0.0;
  itemMat[5] = 1.0;
  itemMat[6] = itemMat[7]  = itemMat[8] = itemMat[9] = 0.0;
  itemMat[10] = 1.0;
  itemMat[11] = 0.0;
  itemMat[12] = pos[0];
  itemMat[13] = pos[1];
  itemMat[14] = pos[2];
  itemMat[15] = 1.0;
}



menuItem::~menuItem()
{
  delete model;
  M.clear();
}



void menuItem::addSubMenu(menuItem *m)
{
  M.push(m);
}



void menuItem::draw(int i, vjMatrix *headMatrix)
{
  GLdouble myMat[16];

  // update the PQP-model
  glPushMatrix();
     glLoadIdentity();
     glMultMatrixf(headMatrix->getFloatPtr());
     glMultMatrixd(itemMat);
     glGetDoublev(GL_MODELVIEW_MATRIX, myMat);
     OGLtoMV(R, T, myMat);
  glPopMatrix();  


  if (M.size() > 0 && i==1) {
    if (visible == 0) {
      glPushMatrix();
        glLoadIdentity();
        glMultMatrixf(headMatrix->getFloatPtr());
	glMultMatrixd(itemMat);
	glTranslatef(0.0, 0.0, 0.1);
        glCallList(item);
      glPopMatrix();
    }
    else {
      menuItem *m;
      forall(m, M) m->draw(0, headMatrix);
    }
  }
  else {
    if (i == 0) { 
      glPushMatrix();
        glLoadIdentity();
        glMultMatrixf(headMatrix->getFloatPtr());
	glMultMatrixd(itemMat);
        glCallList(item);
      glPopMatrix();
    }
    else { 
      glPushMatrix();
        glLoadIdentity();
        glMultMatrixf(headMatrix->getFloatPtr());
	glMultMatrixd(itemMat);
	glTranslatef(0.0, 0.0, 0.05);
        glCallList(item);
      glPopMatrix();
      glPushMatrix();
        glLoadIdentity();
        glMultMatrixf(headMatrix->getFloatPtr());
	glMultMatrixd(itemMat);
        glTranslatef(0.0, 0.0, 0.10);
        glCallList(item);
      glPopMatrix();
      glPushMatrix();
        glLoadIdentity();
        glMultMatrixf(headMatrix->getFloatPtr());
	glMultMatrixd(itemMat);
	glTranslatef(0.0, 0.0, 0.15);
        glCallList(item);
      glPopMatrix();
    }
  }

}

