#ifndef _VMENUUUU_HH_
#define _VMENUUUU_HH_
/*
  vmenu.h

  Frode Aarstad
  */

#include <LEDA/vector.h>
#include <LEDA/string.h>
#include <LEDA/list.h>
#include <GL/gl.h>
#include <PQP.h>
#include <Math/vjMatrix.h>
#include <Math/vjVec3.h>
#include "load.image.h"
#include "MatVec.h"

class menuItem 
{
public:

  menuItem(float, float, vector size, char * texture, string text);
  ~menuItem();

  void addSubMenu(menuItem *);
  void draw(int, vjMatrix *head);

  
  PQP_Model *model;
  PQP_REAL R[3][3];
  PQP_REAL T[3];
  string id;
  list <menuItem *> M;
  int visible;

private:
  int item;
  GLuint item_texture[1];
  GLdouble itemMat[16];
};






class vmenu
{
public:
  vmenu(float, float, vjVec3);
  ~vmenu();
  
  void addMenuItem(menuItem *);
  void draw(vjMatrix *head);
  void reset();
  void hideSubmenu();
  string selected(vjMatrix *wand, vjMatrix *head);
  int drawSubmenu(string, vjMatrix *head);
  int visibleSubmenu();

private:
  list <menuItem *> M;
  int vmenu_base; 
  int frame;
  vjVec3 pos_vec;
  PQP_Model *wandModel;
  PQP_REAL Rwand[3][3], Twand[3];
};
#endif



