#ifndef _WORLDPQP_H_ 
#define _WORLDPQP_H_
/*
  worldPQP.h

  Frode Aarstad
 */

#include <LEDA/file.h>
#include <LEDA/array.h>
#include <LEDA/list.h>
#include <LEDA/matrix.h>
#include <LEDA/point.h>
#include <LEDA/polygon.h>
#include <LEDA/stream.h>
#include <LEDA/string.h>
#include <LEDA/vector.h>
#include <LEDA/graph.h>


#include "world.h"
#include "maze3D.h"
#include "robot.h"


class worldPQP: public World {
public:
  worldPQP(maze3D *,robot *, string);
  virtual ~worldPQP() {};

  virtual bool CollisionFree(const vector &q);
  virtual double DistanceComp(const vector &q);
  virtual vector LinearInterpolate(const vector &q1, const vector &q2, 
				   const double &a);

  // not implemented
  virtual list<polygon> EnvironmentToPolygons() {};
  virtual list<polygon> RobotToPolygons(const vector &q) {};

 
private:
  maze3D *theMaze;
  robot  *theRobot;
};
#endif

